THREADSCOPE(1)

NAME
threadscope - a graphical thread profiler for Haskell GHC programs

SYNOPSIS
threadscope [program.eventlog]

DESCRIPTION
Threadscope is a graphical thread profiler for Haskell programs.

It parses and displays the content of .eventlog files emitted by the GHC 6.12.1 and later runtimes, showing a timeline of spark creation, spark-to-thread promotions and garbage collections.

This helps debugging the parallel performance of Haskell programs, making easier to check that work is well balanced across the available processors and spot performance issues relating to garbage collection or poor load balancing.

ARGUMENTS
threadscope takes the name of the GHC RTS event-log file to process as its single argument. If no filename is given, threadscope starts with an empty workspace, where any event-log file can be loaded by means of the GUI file browser facilities.

USAGE
In order for threadscope to be useful, you have to compile your Haskell program to use GHC's threaded run-time and also to create runtime profile logs. This can be accomplished with the following command line options to ghc(1)

    $ ghc -threaded -eventlog --make Foo.hs -o foo

Once the program is built, execute it using the multithreaded run-time, specifying the number of HECs (Haskell Execution Contexts) to use in the usual manner, but also requesting the creation of an event log. For example, to use two HECs and create an event log you would use

    $ foo +RTS -N2 -ls -RTS ...

Once the program runs to completion, a file named foo.eventlog is produced. You can start threadscope from the shell prompt passing the event-log filename as the single argument, or you can start threadscope from the desktop menus and use its file browsing capabilities to find and open it.

SEE ALSO
ghc(1)

AUTHOR
threadscope was written by

    Simon Marlow <marlowsd@gmail.com>
    Donnie Jones <donnie@darthik.com>
    Satnam Singh <s.singh@ieee.org>

This manual page was written by

    Ernesto Hernández-Novich (USB) <emhn@usb.ve>

for the Debian project (and may be used by others).